; 
;                               Build this project with MAKEIT.BAT
; 

    include \masm32\include\masm32rt.inc                    ; include the MASM32 runtime library

    .686p                                                   ; 686 privileged instructions
    .MMX                                                    ; multimedia extensions
    .XMM                                                    ; extended multimedia extensions

    include cpuid_lib\cpuid.inc
    includelib cpuid_lib\cpuid.lib

    include Project.inc

; 

    .code                                                   ; start the code section of the application

start:                                                      ; the application entry point

    hInstance cgv(GetModuleHandle, NULL)                    ; create GLOBAL instance handle

    invoke DialogBoxParam,hInstance,1000,0,ADDR WndProc,0   ; Call the dialog box from the resource file

    invoke ExitProcess,eax                                  ; terminate the current running process

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL icce:INITCOMMONCONTROLSEX
    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE
    LOCAL itst  :ITST

    switch uMsg
      case WM_INITDIALOG
        GLOBAL hWnd dd ?                                    ; create a GLOBAL handle for the main window
        m2m hWnd, hWin                                      ; Copy hWin to GLOBAL variable

        hIcon cgv(LoadIcon,hInstance,500)

        hImg cgv(LoadImage,hInstance,500,IMAGE_ICON,64,64,LR_DEFAULTSIZE or LR_LOADTRANSPARENT)

        invoke SendMessage,hWin,WM_SETICON,1,hIcon

      ; --------------------------------------------------
      ; NOTE : cgv (create global value) is a MACRO that
      ; creates a GLOBAL scope value in the .DATA? section
      ; of this executable file. Do NOT create a LOCAL or
      ; GLOBAL value of the same name or you will get
      ; duplicate errors. Also note that each name must be
      ; unique to avoid duplicate errors.
      ; --------------------------------------------------
        hButton1 cgv(GetDlgItem,hWin,1001)
        hButton2 cgv(GetDlgItem,hWin,1002)
        hStatic1 cgv(GetDlgItem,hWin,1003)
        hStatic2 cgv(GetDlgItem,hWin,1004)
        hStatic3 cgv(GetDlgItem,hWin,1005)
        hStatic4 cgv(GetDlgItem,hWin,1006)
        hStatic5 cgv(GetDlgItem,hWin,1007)
        hStatic6 cgv(GetDlgItem,hWin,1008)
        hStatic7 cgv(GetDlgItem,hWin,1009)
        hStatic8 cgv(GetDlgItem,hWin,1010)
        hStatic9 cgv(GetDlgItem,hWin,1011)
        hStatic10 cgv(GetDlgItem,hWin,1012)
        hStatic11 cgv(GetDlgItem,hWin,1013)
        hStatic12 cgv(GetDlgItem,hWin,1014)
        hStatic13 cgv(GetDlgItem,hWin,1015)
        hStatic14 cgv(GetDlgItem,hWin,1016)
        hStatic15 cgv(GetDlgItem,hWin,1017)
        hStatic16 cgv(GetDlgItem,hWin,1018)
        hStatic17 cgv(GetDlgItem,hWin,1019)
        hStatic18 cgv(GetDlgItem,hWin,1020)

        hIconImg cgv(GetDlgItem,hWin,1021)

        invoke SendMessage,hIconImg,STM_SETIMAGE,IMAGE_ICON,hImg

        return 1

      case WM_COMMAND
        switch wParam
          case 1001

            .if rv(is_cpuid) == 0
              fn SetWindowText,hStatic10,"CPUID not supported"
              ret
            .else
              fn SetWindowText,hStatic10,"CPUID is supported"
            .endif

            mov pbuf, ptr$(buffer)

            fn Get_Brand_String,pbuf
            fn SetWindowText,hStatic11,pbuf

            fn get_cpu_id_string,pbuf
            mov pbuf, rv(szMonoSpace,pbuf)
            fn SetWindowText,hStatic12,pbuf

            fn intel_mm_set,ADDR itst

            .if itst.sse42 == 1
              fn SetWindowText,hStatic13,"SSE4.2 Supported"
            .else
              fn SetWindowText,hStatic13,"SSE4.2 Not Supported"
            .endif

            .if itst.sse41 == 1
              fn SetWindowText,hStatic14,"SSE4.1 Supported"
            .else
              fn SetWindowText,hStatic14,"SSE4.1 Not Supported"
            .endif

            .if itst.sse3 == 1
              fn SetWindowText,hStatic15,"SSE3 Supported"
            .else
              fn SetWindowText,hStatic15,"SSE3 Not Supported"
            .endif

            .if itst.sse2 == 1
              fn SetWindowText,hStatic16,"SSE2 Supported"
            .else
              fn SetWindowText,hStatic16,"SSE2 Not Supported"
            .endif

            .if itst.sse == 1
              fn SetWindowText,hStatic17,"SSE Supported"
            .else
              fn SetWindowText,hStatic17,"SSE Not Supported"
            .endif

            .if itst.mmx == 1
              fn SetWindowText,hStatic18,"MMX Supported"
            .else
              fn SetWindowText,hStatic18,"MMX Not Supported"
            .endif

          case 1002
            jmp exit_dialog

        endsw

      case WM_CLOSE
        exit_dialog:                                        ; jump to this label to close program
        invoke EndDialog,hWin,0

    endsw

    return 0

WndProc endp

; 

end start

