; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive
 
    include \masm32\macros\macros.asm
    szCopy PROTO :DWORD,:DWORD

    .code       ; code section

; 

get_cpu_id_string proc pBuffer:DWORD

    LOCAL basicinf  :DWORD
    LOCAL extended  :DWORD

    mov eax, 0                                  ; call basic info function
    cpuid
    mov basicinf, eax

    mov eax, 80000000h                          ; call extended info function
    cpuid
    mov extended, eax

    .if extended == 80000004h || extended == 80000008h
      jmp getID
    .endif

    .if basicinf == 00000001h
      cst pBuffer, "i486 or early Pentium Processor"
      ret
    .elseif basicinf == 00000002h
      cst pBuffer, "Pentium Pro, II or Celeron Processor"
      ret
    .elseif basicinf == 00000003h
      cst pBuffer, "Pentium III Processor"
      ret
    .else
      cst pBuffer, "Cannot Identify x86 Processor"
      ret
    .endif

  getID:

    push ebx
    push esi

    mov esi, pBuffer                    ; load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx

    ret

get_cpu_id_string endp

; 

end
